MODULE REBARTY

USE DFWINTY
!USE COMCTLTY

IMPLICIT NONE

!====== Toolbar control styles =============================

INTEGER,PARAMETER:: TBSTYLE_FLAT             =#800
INTEGER,PARAMETER:: TBSTYLE_LIST             =#1000
INTEGER,PARAMETER:: TBSTYLE_CUSTOMERASE      =#2000
INTEGER,PARAMETER:: TBSTYLE_REGISTERDROP     =#4000
INTEGER,PARAMETER:: TBSTYLE_TRANSPARENT      =#8000
INTEGER,PARAMETER:: TBSTYLE_EX_DRAWDDARROWS  =#00000001
                                         
INTEGER,PARAMETER:: TBSTYLE_DROPDOWN         =#0008
INTEGER,PARAMETER:: TBSTYLE_AUTOSIZE         =#0010
INTEGER,PARAMETER:: TBSTYLE_NOPREFIX         =#0020

!====== General common control styles ======================

INTEGER, PARAMETER:: CCS_TOP                 =#00000001
INTEGER, PARAMETER:: CCS_NOMOVEY             =#00000002
INTEGER, PARAMETER:: CCS_BOTTOM              =#00000003
INTEGER, PARAMETER:: CCS_NORESIZE            =#00000004
INTEGER, PARAMETER:: CCS_NOPARENTALIGN       =#00000008
INTEGER, PARAMETER:: CCS_ADJUSTABLE          =#00000020
INTEGER, PARAMETER:: CCS_NODIVIDER           =#00000040

INTEGER, PARAMETER:: CCS_VERT                =#00000080
INTEGER, PARAMETER:: CCS_LEFT                =(CCS_VERT .OR. CCS_TOP)
INTEGER, PARAMETER:: CCS_RIGHT               =(CCS_VERT .OR. CCS_BOTTOM)
INTEGER, PARAMETER:: CCS_NOMOVEX             =(CCS_VERT .OR. CCS_NOMOVEY)

TYPE T_INITCOMMONCONTROLSEX 
    INTEGER dwSize
    INTEGER dwICC
END TYPE T_INITCOMMONCONTROLSEX 

INTEGER, PARAMETER:: ICC_LISTVIEW_CLASSES =#00000001 ! listview, header
INTEGER, PARAMETER:: ICC_TREEVIEW_CLASSES =#00000002 ! treeview, tooltips
INTEGER, PARAMETER:: ICC_BAR_CLASSES      =#00000004 ! toolbar, statusbar, trackbar, tooltips
INTEGER, PARAMETER:: ICC_TAB_CLASSES      =#00000008 ! tab, tooltips
INTEGER, PARAMETER:: ICC_UPDOWN_CLASS     =#00000010 ! updown
INTEGER, PARAMETER:: ICC_PROGRESS_CLASS   =#00000020 ! progress
INTEGER, PARAMETER:: ICC_HOTKEY_CLASS     =#00000040 ! hotkey
INTEGER, PARAMETER:: ICC_ANIMATE_CLASS    =#00000080 ! animate
INTEGER, PARAMETER:: ICC_WIN95_CLASSES    =#000000FF
INTEGER, PARAMETER:: ICC_DATE_CLASSES     =#00000100 ! month picker, date picker, time picker, updown
INTEGER, PARAMETER:: ICC_USEREX_CLASSES   =#00000200 ! comboex
INTEGER, PARAMETER:: ICC_COOL_CLASSES     =#00000400 ! rebar (coolbar) control
INTEGER, PARAMETER:: ICC_INTERNET_CLASSES =#00000800
INTEGER, PARAMETER:: ICC_PAGESCROLLER_CLASS =#00001000   ! page scroller
INTEGER, PARAMETER:: ICC_NATIVEFNTCTL_CLASS =#00002000   ! native font control

INTEGER, PARAMETER:: ODT_HEADER             = 100
INTEGER, PARAMETER:: ODT_TAB                = 101
INTEGER, PARAMETER:: ODT_LISTVIEW           = 102

!====== Rebars ======================

CHARACTER*(*),PARAMETER::  REBARCLASSNAME    ="ReBarWindow32"C

INTEGER, PARAMETER:: RBN_FIRST               = -831       ! rebar
INTEGER, PARAMETER:: RBN_LAST                = -859
INTEGER, PARAMETER:: RBIM_IMAGELIST  =#00000001

INTEGER, PARAMETER:: RBS_TOOLTIPS        =#0100
INTEGER, PARAMETER:: RBS_VARHEIGHT       =#0200
INTEGER, PARAMETER:: RBS_BANDBORDERS     =#0400
INTEGER, PARAMETER:: RBS_FIXEDORDER      =#0800
INTEGER, PARAMETER:: RBS_REGISTERDROP    =#1000
INTEGER, PARAMETER:: RBS_AUTOSIZE        =#2000
INTEGER, PARAMETER:: RBS_VERTICALGRIPPER =#4000  ! this always has the vertical gripper (default for horizontal mode)
INTEGER, PARAMETER:: RBS_DBLCLKTOGGLE    =#8000

TYPE T_REBARINFO
    INTEGER cbSize
    INTEGER fMask
    INTEGER himl
END TYPE T_REBARINFO

INTEGER, PARAMETER:: RBBS_BREAK          =#00000001  ! break to new line
INTEGER, PARAMETER:: RBBS_FIXEDSIZE      =#00000002  ! band can't be sized
INTEGER, PARAMETER:: RBBS_CHILDEDGE      =#00000004  ! edge around top & bottom of child window
INTEGER, PARAMETER:: RBBS_HIDDEN         =#00000008  ! don't show
INTEGER, PARAMETER:: RBBS_NOVERT         =#00000010  ! don't show when vertical
INTEGER, PARAMETER:: RBBS_FIXEDBMP       =#00000020  ! bitmap doesn't move during band resize
INTEGER, PARAMETER:: RBBS_VARIABLEHEIGHT =#00000040  ! allow autosizing of this child vertically
INTEGER, PARAMETER:: RBBS_GRIPPERALWAYS  =#00000080  ! always show the gripper
INTEGER, PARAMETER:: RBBS_NOGRIPPER      =#00000100  ! never show the gripper
INTEGER, PARAMETER:: RBBS_USECHEVRON     =#00000200  ! show the chevron button

INTEGER, PARAMETER:: RBBIM_STYLE         =#00000001
INTEGER, PARAMETER:: RBBIM_COLORS        =#00000002
INTEGER, PARAMETER:: RBBIM_TEXT          =#00000004
INTEGER, PARAMETER:: RBBIM_IMAGE         =#00000008
INTEGER, PARAMETER:: RBBIM_CHILD         =#00000010
INTEGER, PARAMETER:: RBBIM_CHILDSIZE     =#00000020
INTEGER, PARAMETER:: RBBIM_SIZE          =#00000040
INTEGER, PARAMETER:: RBBIM_BACKGROUND    =#00000080
INTEGER, PARAMETER:: RBBIM_ID            =#00000100
INTEGER, PARAMETER:: RBBIM_IDEALSIZE     =#00000200
INTEGER, PARAMETER:: RBBIM_LPARAM        =#00000400
INTEGER, PARAMETER:: RBBIM_HEADERSIZE    =#00000800  ! control the size of the header

TYPE T_REBARBANDINFO
    INTEGER  cbSize
    INTEGER  fMask
    INTEGER  fStyle
    INTEGER  clrFore
    INTEGER  clrBack
    INTEGER  lpText
    INTEGER  cch
    INTEGER  iImage
    INTEGER  hwndChild
    INTEGER  cxMinChild
    INTEGER  cyMinChild
    INTEGER  cx
    INTEGER  hbmBack
    INTEGER  wID
    INTEGER  cyChild
    INTEGER  cyMaxChild
    INTEGER  cyIntegral
    INTEGER  cxIdeal
    INTEGER  lParam
    INTEGER  cxHeader
END TYPE T_REBARBANDINFO

INTEGER, PARAMETER:: RB_INSERTBANDA  =(WM_USER +  1)
INTEGER, PARAMETER:: RB_DELETEBAND   =(WM_USER +  2)
INTEGER, PARAMETER:: RB_GETBARINFO   =(WM_USER +  3)
INTEGER, PARAMETER:: RB_SETBARINFO   =(WM_USER +  4)
!INTEGER, PARAMETER:: RB_GETBANDINFO  =(WM_USER +  5)
INTEGER, PARAMETER:: RB_SETBANDINFOA =(WM_USER +  6)
INTEGER, PARAMETER:: RB_SETPARENT    =(WM_USER +  7)
INTEGER, PARAMETER:: RB_HITTEST      =(WM_USER +  8)
INTEGER, PARAMETER:: RB_GETRECT      =(WM_USER +  9)
INTEGER, PARAMETER:: RB_INSERTBANDW  =(WM_USER +  10)
INTEGER, PARAMETER:: RB_SETBANDINFOW =(WM_USER +  11)
INTEGER, PARAMETER:: RB_GETBANDCOUNT =(WM_USER +  12)
INTEGER, PARAMETER:: RB_GETROWCOUNT  =(WM_USER +  13)
INTEGER, PARAMETER:: RB_GETROWHEIGHT =(WM_USER +  14)
INTEGER, PARAMETER:: RB_IDTOINDEX    =(WM_USER +  16) ! wParam == id
INTEGER, PARAMETER:: RB_GETTOOLTIPS  =(WM_USER +  17)
INTEGER, PARAMETER:: RB_SETTOOLTIPS  =(WM_USER +  18)
INTEGER, PARAMETER:: RB_SETBKCOLOR   =(WM_USER +  19) ! sets the default BK color
INTEGER, PARAMETER:: RB_GETBKCOLOR   =(WM_USER +  20) ! defaults to CLR_NONE
INTEGER, PARAMETER:: RB_SETTEXTCOLOR =(WM_USER +  21)
INTEGER, PARAMETER:: RB_GETTEXTCOLOR =(WM_USER +  22) ! defaults to =#00000000
INTEGER, PARAMETER:: RB_SIZETORECT   =(WM_USER +  23) ! resize the rebar/break bands and such to this rect =(lparam)


INTEGER, PARAMETER:: RB_INSERTBAND   =RB_INSERTBANDA
INTEGER, PARAMETER:: RB_SETBANDINFO  =RB_SETBANDINFOA

! for manual drag control
! lparam == cursor pos
        ! -1 means do it yourself.
        ! -2 means use what you had saved before
INTEGER, PARAMETER:: RB_BEGINDRAG    =(WM_USER + 24)
INTEGER, PARAMETER:: RB_ENDDRAG      =(WM_USER + 25)
INTEGER, PARAMETER:: RB_DRAGMOVE     =(WM_USER + 26)
INTEGER, PARAMETER:: RB_GETBARHEIGHT =(WM_USER + 27)
INTEGER, PARAMETER:: RB_GETBANDINFOW =(WM_USER + 28)
INTEGER, PARAMETER:: RB_GETBANDINFOA =(WM_USER + 29)

INTEGER, PARAMETER:: RB_GETBANDINFO   =RB_GETBANDINFOA

INTEGER, PARAMETER:: RB_MINIMIZEBAND =(WM_USER + 30)
INTEGER, PARAMETER:: RB_MAXIMIZEBAND =(WM_USER + 31)

INTEGER, PARAMETER:: RB_GETBANDBORDERS =(WM_USER + 34)  ! returns in lparam = lprc the amount of edges added to band wparam

INTEGER, PARAMETER:: RB_SHOWBAND     =(WM_USER + 35)      ! show/hide band
INTEGER, PARAMETER:: RB_SETPALETTE   =(WM_USER + 37)
INTEGER, PARAMETER:: RB_GETPALETTE   =(WM_USER + 38)
INTEGER, PARAMETER:: RB_MOVEBAND     =(WM_USER + 39)

INTEGER, PARAMETER:: RBN_HEIGHTCHANGE    =(RBN_FIRST - 0)

INTEGER, PARAMETER:: RBN_GETOBJECT       =(RBN_FIRST - 1)
INTEGER, PARAMETER:: RBN_LAYOUTCHANGED   =(RBN_FIRST - 2)
INTEGER, PARAMETER:: RBN_AUTOSIZE        =(RBN_FIRST - 3)
INTEGER, PARAMETER:: RBN_BEGINDRAG       =(RBN_FIRST - 4)
INTEGER, PARAMETER:: RBN_ENDDRAG         =(RBN_FIRST - 5)
INTEGER, PARAMETER:: RBN_DELETINGBAND    =(RBN_FIRST - 6)     ! Uses NMREBAR
INTEGER, PARAMETER:: RBN_DELETEDBAND     =(RBN_FIRST - 7)     ! Uses NMREBAR
INTEGER, PARAMETER:: RBN_CHILDSIZE       =(RBN_FIRST - 8)


TYPE T_NMREBARCHILDSIZE
    TYPE (T_NMHDR) hdr
    INTEGER uBand
    INTEGER wID
    TYPE(T_RECT) rcChild
    TYPE(T_RECT) rcBand
END TYPE T_NMREBARCHILDSIZE

TYPE T_NMREBAR
    TYPE (T_NMHDR) hdr
    INTEGER dwMask           ! RBNM_*
    INTEGER uBand
    INTEGER fStyle
    INTEGER wID
    INTEGER lParam
END TYPE T_NMREBAR

! Mask flags for NMREBAR
INTEGER, PARAMETER:: RBNM_ID         =#00000001
INTEGER, PARAMETER:: RBNM_STYLE      =#00000002
INTEGER, PARAMETER:: RBNM_LPARAM     =#00000004


TYPE T_NMRBAUTOSIZE
    TYPE (T_NMHDR) hdr
    LOGICAL fChanged
    TYPE(T_RECT) rcTarget
    TYPE(T_RECT) rcActual
END TYPE T_NMRBAUTOSIZE

INTEGER, PARAMETER:: RBHT_NOWHERE    =#0001
INTEGER, PARAMETER:: RBHT_CAPTION    =#0002
INTEGER, PARAMETER:: RBHT_CLIENT     =#0003
INTEGER, PARAMETER:: RBHT_GRABBER    =#0004

TYPE T_RB_HITTESTINFO
    TYPE (T_POINT) pt
    INTEGER flags
    INTEGER iBand
END TYPE T_RB_HITTESTINFO

END MODULE REBARTY
!=======================================================================
MODULE REBAR

USE REBARTY

INTERFACE
      LOGICAL FUNCTION InitCommonControlsEx(ICC)
      !DEC$ATTRIBUTES STDCALL, ALIAS: '_InitCommonControlsEx@4'::  InitCommonControlsEx
      USE REBARTY
      !DEC$ATTRIBUTES REFERENCE::    ICC
      TYPE(T_INITCOMMONCONTROLSEX)::    ICC
      END FUNCTION
END INTERFACE

END MODULE REBAR